import { CompositeLayer } from '@deck.gl/core';
import { CircleLayer } from './node-layers/circle-layer';
import { ImageLayer } from './node-layers/image-layer';
import { LabelLayer } from './node-layers/label-layer';
import { RectangleLayer } from './node-layers/rectangle-layer';
import { ZoomableMarkerLayer } from './node-layers/zoomable-marker-layer';
import { EdgeLayer } from './edge-layer';
import { EdgeLabelLayer } from './edge-layers/edge-label-layer';
import { FlowLayer } from './edge-layers/flow-layer';
export declare class GraphLayer extends CompositeLayer {
    static defaultProps: {
        pickable: boolean;
    };
    forceUpdate: () => void;
    constructor(props: any);
    initializeState(): void;
    shouldUpdateState({ changeFlags }: {
        changeFlags: any;
    }): any;
    updateState({ props }: {
        props: any;
    }): void;
    finalize(): void;
    createNodeLayers(): (CircleLayer | ImageLayer | LabelLayer | RectangleLayer | ZoomableMarkerLayer)[];
    createEdgeLayers(): (EdgeLayer | (EdgeLabelLayer | FlowLayer)[])[];
    onClick(info: any, event: any): boolean;
    onHover(info: any, event: any): boolean;
    onDragStart(info: any, event: any): void;
    onDrag(info: any, event: any): void;
    onDragEnd(info: any, event: any): void;
    renderLayers(): ((EdgeLayer | (EdgeLabelLayer | FlowLayer)[])[] | (CircleLayer | ImageLayer | LabelLayer | RectangleLayer | ZoomableMarkerLayer)[])[];
}
