// deck.gl-community
// SPDX-License-Identifier: MIT
// Copyright (c) vis.gl contributors

// react-graph-layers core
export {GraphEngine} from './core/graph-engine';
export {Graph} from './core/graph';
export {Node} from './core/node';
export {Edge} from './core/edge';
export {
  NODE_STATE,
  NODE_TYPE,
  EDGE_TYPE,
  EDGE_DECORATOR_TYPE,
  LAYOUT_STATE,
  MARKER_TYPE
} from './core/constants';

// react-graph-layers layouts
export {BaseLayout} from './core/base-layout';
export {D3ForceLayout} from './layouts/d3-force/d3-force-layout';
export {GPUForceLayout} from './layouts/gpu-force/gpu-force-layout';
export {SimpleLayout} from './layouts/simple-layout/simple-layout';

// react-graph-layers loaders
export {JSONLoader} from './loaders/json-loader';
export {basicNodeParser} from './loaders/node-parsers';
export {basicEdgeParser} from './loaders/edge-parsers';

// react-graph-layers utils
export {createGraph} from './utils/create-graph';
export * from './utils/layer-utils';
export * from './utils/log';

// deck.gl components
export {GraphLayer} from './layers/graph-layer';
export {EdgeLayer} from './layers/edge-layer';

// DEPRECATED

/** @deprecated Use EdgeLayer */
export {EdgeLayer as CompositeEdgeLayer} from './layers/edge-layer';
